<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="180px" style="margin: 0 12rem;">
        <!-- Botón regresar -->
        <ReturnButton v-on:clickEvent="returnButtonModal = true" title="Regresar" :offsetArrow="21" :spanTitle="2" class="text-end" style="margin-bottom: 2.5rem"></ReturnButton>
        
        <!-- Modal botón regresar -->
        <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnButtonModal = false" @btnEvent="viewList" v-on:eventBtn="returnButtonModal = false">
        </AppModalReturn>

        <!-- Título -->
        <h3 class="text-red" style="margin-bottom: 10px;">REPOSICIÓN</h3>
        <el-card class="report-title">
          <el-row type="flex" justify="space-between">
            <el-col :span="12">{{ material.originalTitle }}</el-col>
          </el-row>          
        </el-card>
      </el-header>

      <el-main style="margin: 0 12rem; overflow: initial;">
        <h3 class="text-orange" style="margin: 2rem 0px 2rem; ">REPOSICIÓN DEL MATERIAL</h3>
        <el-row style="padding: 10px 10px 20px 20px; margin-bottom: 1rem;">
          <el-col :span="4" class="fonts-bold-general" style="margin-top: 0.5rem">Fecha de Llegada</el-col>
          <el-col :span="4">
            <el-date-picker
              v-model="arrivalDate" :disabled="true"
              type="date"
              size="small"
              format="dd/MM/yyyy"
              style="width: 100%">
            </el-date-picker>
          </el-col>
        </el-row>

        <hr class="line-report">
        <h3 class="text-orange" style="margin: 2rem 0px 2rem; ">OBSERVACIONES TÉCNICAS</h3>
        <el-tabs type="card" style="margin: 3rem 0" class="tabContentStyle" v-model="activeName" @tab-click="changeTab(activeName)">
          <el-tab-pane label="Color">
            <div slot="label" class="tab-title">
              <img src="../../assets/images/icono-color.svg" width="20px" alt="icono-color">
              <img src="../../assets/images/icono-color-white.svg" width="20px" alt="icono-color">
              <span>COLOR</span>
            </div>
            <div style="margin:2rem 1rem">
              <el-row style="margin: 0 0 1rem">
                <el-col :span="12" :offset="1">
                  <el-checkbox-group v-model="colorObserv" @change="changeCheckbox(colorObserv, 'colorObserv', 'disabledColor', 'needRepColor')">
                    <el-checkbox v-for="item in arrColor" :key="item" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                  </el-checkbox-group>
                </el-col>
                <el-col :span="6" :offset="1">
                  <div class="box-shadow" style="padding: 1rem">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                    <el-radio v-model="needRepColor" @change="changeReplacement(needRepColor, 'repColor')" label="SÍ" :disabled="disabledColor" style="display:block; margin:0">SÍ</el-radio>
                    <el-radio v-model="needRepColor" @change="changeReplacement(needRepColor, 'repColor')" label="NO" :disabled="disabledColor" style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                  </div>
                </el-col>
              </el-row>
              <el-row style="margin: 0 0 3rem">
                <el-col :span="2" :offset="1">Otro:</el-col>
                <el-col :span="6"><el-input v-model="anotherColor" size="small"></el-input></el-col>
              </el-row>
            </div>
          </el-tab-pane>
          <el-tab-pane label="Audio">
            <div slot="label" class="tab-title">
              <img src="../../assets/images/icono-audio.svg" width="22px" alt="icono-audio"> 
              <img src="../../assets/images/icono-audio-white.svg" width="22px" alt="icono-audio"> 
              <span>AUDIO</span>
            </div>
            <div style="margin:2rem 1rem">
              <el-row style="margin: 0 0 1rem">
                <el-col :span="12" :offset="1">
                  <el-checkbox-group v-model="audioObserv" @change="changeCheckbox(audioObserv, 'audioObserv', 'disabledAudio', 'needRepAudio')">
                    <el-checkbox v-for="item in arrAudio" :key="item" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                  </el-checkbox-group>
                </el-col>
                <el-col :span="6" :offset="1">
                  <div class="box-shadow" style="padding: 1rem">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                    <el-radio v-model="needRepAudio" @change="changeReplacement(needRepAudio, 'repAudio')" label="SÍ" :disabled="disabledAudio" style="display:block; margin:0">SÍ</el-radio>
                    <el-radio v-model="needRepAudio" @change="changeReplacement(needRepAudio, 'repAudio')" label="NO" :disabled="disabledAudio" style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                  </div>
                </el-col>
              </el-row>
              <el-row style="margin: 0 0 3rem">
                <el-col :span="2" :offset="1">Otro:</el-col>
                <el-col :span="6"><el-input v-model="anotherAudio" size="small"></el-input></el-col>
              </el-row>
            </div>
          </el-tab-pane>
          <el-tab-pane label="Video">
            <div slot="label" class="tab-title">
              <img src="../../assets/images/icono-video.svg" width="22px" alt="icono-video"> 
              <img src="../../assets/images/icono-video-white.svg" width="22px" alt="icono-video"> 
              <span>VIDEO</span>
            </div>
            <div style="margin:2rem 1rem">
              <el-row style="margin: 0 0 1rem">
                <el-col :span="12" :offset="1">
                  <el-checkbox-group v-model="videoObserv" @change="changeCheckbox(videoObserv, 'videoObserv', 'disabledVideo', 'needRepVideo')">
                    <el-checkbox v-for="item in arrVideo" :key="item" :label="item" style="display:block; margin:0; padding:0.5rem 0"></el-checkbox>
                  </el-checkbox-group>
                </el-col>
                <el-col :span="6" :offset="1">
                  <div class="box-shadow" style="padding: 1rem">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">NECESITA REPOSICIÓN</p>
                    <el-radio v-model="needRepVideo" @change="changeReplacement(needRepVideo, 'repVideo')" label="SÍ" :disabled="disabledVideo" style="display:block; margin:0">SÍ</el-radio>
                    <el-radio v-model="needRepVideo" @change="changeReplacement(needRepVideo, 'repVideo')" label="NO" :disabled="disabledVideo" style="display:block; margin:0; padding:0.5rem 0">NO</el-radio>
                  </div>
                </el-col>
              </el-row>
              <el-row style="margin: 0 0 3rem">
                <el-col :span="2" :offset="1">Otro:</el-col>
                <el-col :span="6"><el-input v-model="anotherVideo" size="small"></el-input></el-col>
              </el-row>
            </div>
          </el-tab-pane>
        </el-tabs>
        <div class="text-end">
          <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange" plain>CANCELAR</el-button>
          <el-button @click="validateIfRepIsComplete()" type="primary">ACTUALIZAR</el-button>
        </div>

        <!-- Modal actualizar-->
        <el-dialog
          :visible.sync="returnListMovies"
          width="40%"
          center
          :close-on-press-escape="false"
          :show-close="false"
          custom-class="dialog-orange">
          <el-row>
            <el-col v-if="this.status === 'approved'" :span="6" class="text-center"><img src="../../assets/images/happy.svg" alt="emoticon"></el-col>
            <el-col v-else :span="6" class="text-center"><img src="../../assets/images/confused.svg" alt="confused"></el-col>
            <el-col :span="18">
              <p class="fonts-bold-general" style="margin-bottom: 0.5rem">¡Buen trabajo!</p>
              <p v-if="this.status === 'approved'" style="line-height: 22px">La revisión de {{ material.originalTitle }} ha sido actualizado.</p>
              <p v-if="this.status === 'approved'" style="line-height: 22px">¡Ahora podrás programarlo!</p>
              <p v-else style="line-height: 22px;">La revisión ha sido ingresada. Mientras esté <strong>pendiente de REPOSICIÓN, NO podrás programarlo.</strong></p>
              <div style="margin-top: 4rem; text-align: right;">
                <el-button @click="returnListMovies = false" v-on:click="viewList" class="bg-orange text-white border-none">Aceptar</el-button>              
              </div>
            </el-col>
          </el-row>
        </el-dialog>

        <!-- Modal botón cancelar -->
        <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="viewList()"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
        </AppModalDanger>

        <!-- Modal Advertencia de Reposición -->
        <app-modal :show-dialog.sync="showModalReposition" v-if="showModalReposition" nameClass="dialog-red" :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="65px" textBold="¡Un momento!"
          :parrafo="parrafoModalReposition" btn1="" btn2="" >
        </app-modal>
      </el-main>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import ReturnButton from '@/components/ReturnButton.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import {HTTP} from '../../main.js'
import AppModalReturn from '@/components/AppModalReturn.vue'
import AppModal from '@/components/AppModal.vue'

const contObsOptions = ['Lenguaje inapropiado', 'Violencia física y/o psicológica', 'Sangre', 'Alcohol y drogas', 'Desnudos y/o sexo', 'Muerte y crímenes']
const colorOptions = ['OK', 'Setup Alto o Pedestal Alto (Lavado)', 'Desbalanceado (Fades Tend. Al Rojo)', 'Saturación de Croma (Rojos muy vivos)']
const audioOptions = ['OK', 'Sin Audio', 'Volumen Bajo', 'Entrecortado', 'Saturado (Volumen muy alto)', 'CH1', 'CH2']
const videoOptions = ['OK', 'Drops', 'Rayas', 'Pixeleado', 'Nivel Bajo de Video (Oscuro)']

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModalReturn,
    'app-modal': AppModal,
  },
  data () {
    return {
      material: {},
      returnButtonModal: false,
      returnListMovies: false,
      modalCancelButton: false,
      stateObs: 0,
      arrivalDate: '',
      status: '', //approved, pending
      colorObserv: [], //Ok
      arrColor: colorOptions,
      anotherColor: '', //Ok
      needRepColor: '',
      repColor: '', //Ok
      disabledColor: true,
      previousObsColor: [],
      audioObserv: [], //Ok
      arrAudio: audioOptions,
      anotherAudio: '', //Ok
      needRepAudio: '',
      repAudio: '', //Ok
      disabledAudio: true,
      previousObsAudio: [],
      videoObserv: [], //Ok
      arrVideo: videoOptions,
      anotherVideo: '', //Ok
      needRepVideo: '',
      repVideo: '', //Ok
      disabledVideo: true,
      previousObsVideo: [],
      materialsInContract: [],
      showModalReposition: false,
      parrafoModalReposition: 'Por favor indica si el material necesita reposición.',
      activeName: '0',
      prevTab: '0',
      afiliado: localStorage.getItem('afiliado'),
    }
  },
  created () {
    this.materialObj()
    if(this.afiliado == 'false'){
      /*Getting the support info of the material*/
      let cannedView = localStorage.getItem('cannedView')
      if(cannedView == 'true'){
        let contractCode = this.material.contractCode
        let idMaterial = this.material.__id
        this.getSupportInfo(contractCode, idMaterial)
      }
    }
  },
  methods: {
    materialObj () {
      this.material = JSON.parse(this.$localStorage.get("selectedMaterial"))
      this.arrivalDate = (this.material.infoSupport.length > 0)?this.material.infoSupport[0].arrivalDate : ''
    },
    getSupportInfo(contractCode, idMaterial) {
      HTTP.get(`contracts/contractCode/${contractCode}`)
      .then(res => {
        this.materialsInContract = res.data.contract[0].admittedMaterials
      })
      .catch(err => console.log(err));
    },
    validateIfRepIsComplete(){
      let showAlertArr = 0
      if(this.colorObserv.length !== 0){
        if((this.colorObserv[0] !== 'OK') && (this.needRepColor == '')){
          showAlertArr++
        } 
      }
      
      if(this.audioObserv.length !== 0){
        if((this.audioObserv[0] !== 'OK') && (this.needRepAudio == '')){
          showAlertArr++
        }
      }
         
      if(this.videoObserv.length !== 0){
        if((this.videoObserv[0] !== 'OK') && (this.needRepVideo == '')){
          showAlertArr++
        }
      }
      
      if(showAlertArr>0){
        this.showModalReposition = true
      } else{
        this.toUpdate()
      }
    }, 
    changeDataSupport () { 
      let idMaterial = this.material.__id
      for(var i=0; i< this.materialsInContract.length; i++){
        if(this.materialsInContract[i]._id == idMaterial){
          this.materialsInContract[i].replacement = true
          this.materialsInContract[i].replacementStorage = true
          this.materialsInContract[i].statusMaterial = 1
          this.materialsInContract[i].statusStorage = 1
          this.materialsInContract[i].showreplace = 'REPOSICIÓN'
        }
      }
    },
    toUpdate () {
      if (this.colorObserv == 'OK' && this.audioObserv == 'OK' && this.videoObserv == 'OK') {
        this.status = 'approved'
      } else {
        this.status = 'pending'
      }

      let convertArrivalDate = new Date(this.arrivalDate).toLocaleDateString('en-GB')

      if (this.colorObserv == 'OK') {
        this.repColor = 'showButton'
        this.previousObsColor = [{
          information: this.material.reviewObj.observations[1].detail,
          date: convertArrivalDate
        }]
      }

      if (this.audioObserv == 'OK') {
        this.repAudio = 'showButton'
        this.previousObsAudio = [{
          information: this.material.reviewObj.observations[2].detail,
          date: convertArrivalDate
        }]
      }

      if (this.videoObserv == 'OK') {
        this.repVideo = 'showButton'
        this.previousObsVideo = [{
          information: this.material.reviewObj.observations[3].detail,
          date: convertArrivalDate
        }]
      }

      if (this.anotherColor) {
        this.colorObserv.push(this.anotherColor)
      }

      if (this.anotherAudio) {
        this.audioObserv.push(this.anotherAudio)
      }

      if (this.anotherVideo) {
        this.videoObserv.push(this.anotherVideo)
      }

      this.material.reviewObj.observations = [
        this.material.reviewObj.observations[0],
        {
          observations: "Obs. técnicas de color",
          detail: this.colorObserv.join(', '),
          status: this.repColor,
          previous: this.previousObsColor
        }, {
          observations: "Obs. técnicas de audio",
          detail: this.audioObserv.join(', '),
          status: this.repAudio,
          previous: this.previousObsAudio
        }, {
          observations: "Obs. técnicas de video",
          detail: this.videoObserv.join(', '),
          status: this.repVideo,
          previous: this.previousObsVideo
        }, 
        this.material.reviewObj.observations[4],
      ]
      
      if(!(this.colorObserv[0] == 'OK' && this.audioObserv[0] == 'OK' && this.videoObserv[0] == 'OK')){
        if(this.afiliado == 'true'){
          let storageMat = this.material.storageMat
          storageMat[0].radio = "Pendiente"
          storageMat[0].stateStorage = "Pendiente"
          storageMat[0].stateReplacement = 'REPOSICIÓN'
          storageMat[0].replacementReposition = true
          storageMat[0].replacementStorage = true

          HTTP.patch(`materials/${this.material.__id}`, [  
            {propName: "reviewObj", value: this.material.reviewObj},
            {propName: "reviewStatus", value: this.status},
            {propName: "stateBtnSupport", value: 'INCOMPLETO'},
            {propName: "colorBtnSupport", value: 'danger'},
            {propName: "stateBtnStorageSupport", value: 'INCOMPLETO'},
            {propName: "colorBtnStorageSupport", value: 'danger'},
            {propName: "storageMat", value: storageMat},
          ])
          .then(res => {
            this.returnListMovies = true
          })
          .catch(err => console.log(err));
        } else {
          this.changeDataSupport()
          HTTP.patch(`contracts/contractCode/${this.material.contractCode}`, [
            {propName: "statusContract", value: 'INCOMPLETO'},
            {propName: "statusContractStorage", value: 'INCOMPLETO'},
            {propName: "nameType", value: 'danger'},
            {propName: "nameTypeStorage", value: 'danger'},
            {propName: "admittedMaterials", value: this.materialsInContract}
          ])
          .then(res => {})
          .catch(err => console.log(err));
        }
      }

      if(this.afiliado == 'false'){
        HTTP.patch(`materials/${this.material.__id}`, [
          { propName: "reviewObj", value: this.material.reviewObj}, 
          { propName: "reviewStatus", value: this.status },
        ])
        .then(res => {
          this.returnListMovies = true
        })
        .catch(err => console.log(err))
      }
    },
    viewReportMovie () {
      this.$router.push({name: 'reportMovie'})
    },
    viewList () {
      let routePart = this.material.typeOfContent;
      let cannedView = localStorage.getItem('cannedView')
      // if(routePart == 'Películas') {
      //   routePart = 'Largometrajes'
      // } else if(routePart == 'Programas Especiales') {
      //   routePart = 'specials'
      // } else 
      if(routePart == 'MINI SERIE') {
        routePart = 'miniseries'
      } else if(routePart == 'Especial') {
        routePart = 'specials'
      } else if(routePart == 'ESPECIALES') {
        routePart = 'specials'
      } else if(routePart == 'TELEVISA - ESPECIALES') {
        routePart = 'specials'
      }

      let cannedShow;
      if(cannedView == 'true'){
        cannedShow = true;
      } else {
        cannedShow = false;
      }

      if ( routePart == 'Dibujos' || routePart == 'DIBUJOS' || routePart == 'Largometrajes' || routePart == 'LARGOMETRAJES' || routePart == 'Miniseries' ||  routePart == 'TELENOVELA'  ||  routePart == 'Novelas' || routePart == 'SERIE'  ||  routePart == 'Series') {
        this.$router.push({ name: (routePart).toLowerCase(), params: { canned: cannedShow } });
      } else {
        if(this.afiliado == 'false'){
          this.$router.push({ name: 'typeMaterial', params: { canned: cannedShow } });
        } else {
          this.$router.push({ name: 'tipoDeMaterial'});
        }
      }     
    },
    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-light-red';
      }
    },
    changeCheckbox (value, item, disabled, needEdit) {
      if (value.length > 0) {
        if (value.includes('OK')) {
          this[disabled] = true
          this[item] = ['OK']
          this[needEdit] = ''
        } else {
          this[disabled] = false
        }
      }
    },
    changeReplacement (label, status) {
      if (label === 'SÍ') {
        this[status] = 'En espera de Reposición'
      } else {
        this[status] = 'NO necesita reposición'
      }
    },
    changeTab (val){
      if(this.prevTab !== val){
        if(this.prevTab == '0'){
          if(this.colorObserv.length !== 0){
            if((this.colorObserv[0] !== 'OK') && (this.needRepColor == '')){
              this.showModalReposition = true
            } else{
              this.showModalReposition = false
            }
          }
        } else if(this.prevTab == '1'){
          if(this.audioObserv.length !== 0){
            if((this.audioObserv[0] !== 'OK') && (this.needRepAudio == '')){
              this.showModalReposition = true
            } else{
              this.showModalReposition = false
            }
          }
        } else if(this.prevTab == '2'){
          if(this.videoObserv.length !== 0){
            if((this.videoObserv[0] !== 'OK') && (this.needRepVideo == '')){
              this.showModalReposition = true
            } else{
              this.showModalReposition = false
            }
          }
        }

        this.prevTab = val
      }
    }
  }
}
</script>